-- frmMain.lua
-- written by Habna


resources = {
	--TitanBar = { Background = AppRes.."background.tga" },

	LeftBubble_TopLeftCorner = { Background = AppRes.."lbubble_top_left_corner.tga" },
	LeftBubble_TopRightCorner = { Background = AppRes.."lbubble_top_right_corner.tga" },
	Bubble_MidLeft = { Background = AppRes.."bubble_mid_left.tga" },
	Bubble_BotLeftCorner = { Background = AppRes.."bubble_bot_left_corner.tga" },
	Bubble_Top = { Background = AppRes.."bubble_top.tga" },
	Bubble_Bot = { Background = AppRes.."bubble_bot.tga" },
	Bubble_Mid = { Background = AppRes.."bubble_mid.tga" },
	Bubble_MidRight = { Background = AppRes.."bubble_mid_right.tga" },
	Bubble_BotRightCorner = { Background = AppRes.."bubble_bot_right_corner.tga" },

	RightBubble_TopLeftCorner = { Background = AppRes.."rbubble_top_left_corner.tga" },
	RightBubble_TopRightCorner = { Background = AppRes.."rbubble_top_right_corner.tga" },

	Ring = { Icon = AppRes.."ring.tga" },
	Picker = { Background = AppRes.."picker.jpg" }, --Color picker picture

	Seal = { Icon = AppRes.."seal.tga" }, -- Removed when found in-game 32x32 icon

	RuneKeeper = { Icon = AppRes.."runekeeper.tga" }, -- Removed when found in-game icon
	Warden = { Icon = AppRes.."warden.tga" }, -- Removed when found in-game icon

	Del = { Icon = AppRes.."del.tga" } -- Removed when found in-game delete icon
};


function frmMain()
	--**v Check if TitanBar Reloader is loaded v**
	Turbine.PluginManager.RefreshAvailablePlugins();
	loaded_plugins = Turbine.PluginManager.GetLoadedPlugins();

	TBRChecker = Turbine.UI.Control();
	TBRChecker:SetWantsUpdates( true );
	
	TBRChecker.Update = function( sender, args )
		for k,v in pairs(loaded_plugins) do
			if v.Name == "TitanBar Reloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarReloader' );
				--break;
			end
			if v.Name == "TitanBar Unloader" then
				Turbine.PluginManager.UnloadScriptState( 'TitanBarUnloader' );
				--break;
			end
		end
		TBRChecker:SetWantsUpdates( false );
	end
	--**^

	ToolTipWin = nil;

	_G.TB = {};
	
	TB["win"] = Turbine.UI.Window();
	TB["win"]:SetPosition( 0, 0 );
	TB["win"]:SetSize( screenWidth, 30 );
	--TB["win"]:SetBackground( resources.TitanBar.Background );
	TB["win"]:SetBackColor( Turbine.UI.Color( bcAlpha, bcRed, bcGreen, bcBlue ) );
	--TB["win"]:SetMouseVisible( false ); -- If set to false, menu will not work.
	TB["win"]:SetWantsKeyEvents( true );
	--TB["win"]:SetZOrder( 10 );
	TB["win"]:SetVisible( true );

	
	--**v TitanBar event handlers v**
	TB["win"].KeyDown = function( sender, args )
		-- Hide TitanBar if F12 key is press or reposition UI
		if ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then 
			TB["win"]:SetVisible( not TB["win"]:IsVisible() );
		end
		--if ( args.Action == 268435635 ) then -- toggle HUD
	end

	TB["win"].MouseLeave = function( sender, args )
		if ToolTipWin ~= nil then
			ToolTipWin:SetVisible( false );
			ToolTipWin = nil;
		end
	end

	TB["win"].MouseClick = function( sender, args )
		if ( args.Button == Turbine.UI.MouseButton.Right ) then
			mouseXPos, mouseYPos = Turbine.UI.Display.GetMousePosition();
			_G.sFromCtr = "TitanBar";
			TitanBarMenu:ShowMenu();
		elseif ( args.Button == Turbine.UI.MouseButton.Left ) then
			
		end
	end
	--**
	
	PlayerCurrency = {};
	PlayerCurrencyHandler = {};
	LoadPlayerWallet();

	LoadPlayerProfile();
	if ProfileReload then opt_profile.Click(); end--TitanBar was reloaded cause a profile was loaded

	if PlayerAlign == 1 then
		LoadPlayerMoney();
		if PlayerWalletSize ~= nil or PlayerWalletSize ~= 0 then
			if ShowShards then ImportCtr( "SP" ); end
			if ShowSkirmishMarks then ImportCtr( "SM" ); end
			if ShowMedallions then ImportCtr( "MP" ); end
			if ShowSeals then ImportCtr( "SL" ); end
			if ShowCommendations then ImportCtr( "CP" ); end
		end
	else
		-- Disable Money, DP, Shard, SM (Infos not available in Monster Play)
		ShowMoney, ShowDestinyPoints, ShowSeals, ShowCommendations = false, false, false, false;
		if PlayerWalletSize ~= nil or PlayerWalletSize ~= 0 then
			if ShowShards then ImportCtr( "SP" ); end
			if ShowSkirmishMarks then ImportCtr( "SM" ); end
			if ShowMedallions then ImportCtr( "MP" ); end
		end
	end

	if ShowMoney then ImportCtr( "MI" ); end
	if ShowDestinyPoints then ImportCtr( "DP" ); end
	if ShowShards then import (AppCtrD.."Shards"); end --if ShowShards then ImportCtr( "SP" ); end  --Put back when wallet info are available before plugin load
	if ShowSkirmishMarks then import (AppCtrD.."SkirmishMarks"); end --if ShowSkirmishMarks then ImportCtr( "SM" ); end --Put back when wallet info are available before plugin load
	if ShowMedallions then import (AppCtrD.."Medallions"); end --if ShowMedallions then ImportCtr( "MP" ); end  --Put back when wallet info are available before plugin load
	if ShowSeals then import (AppCtrD.."Seals"); end --if ShowSeals then ImportCtr( "SL" ); end  --Put back when wallet info are available before plugin load
	if ShowCommendations then import (AppCtrD.."Commendations"); end --if ShowCommendations then ImportCtr( "CP" ); end  --Put back when wallet info are available before plugin load

	--**v Workaround for the ItemRemoved that fire before the backpack was updated (Turnine API issue) v**
	ItemRemovedTimer = Turbine.UI.Control();
	
	ItemRemovedTimer.Update = function( sender, args )
		ItemRemovedTimer:SetWantsUpdates( false );
		UpdateBackpackInfos();
	end
	--**
	
	if ShowBagInfos then ImportCtr( "BI" );	end
	if ShowPlayerInfos then ImportCtr( "PI" ); end

	if PlayerAlign == 2 then ShowDurabilityInfos, ShowEquipInfos = false, false; end
	if ShowDurabilityInfos or ShowEquipInfos then GetEquipmentInfos(); end
	if ShowDurabilityInfos then ImportCtr( "DI" ); end
	
	--**v Workaround for the ItemUnequipped that fire before the Equipment was updated (Turnine API issue) v**
	ItemUnEquippedTimer = Turbine.UI.Control();
	
	ItemUnEquippedTimer.Update = function( sender, args )
		ItemUnEquippedTimer:SetWantsUpdates( false );
		UpdateEquipsInfos();
		UpdateDurabilityInfos();
	end
	--**

	if ShowEquipInfos then ImportCtr( "EI" ); end
		
	if ShowPlayerLoc then ImportCtr( "PL" ); end
	if ShowGameTime then ImportCtr( "GT" ); end
	
	--**v Run these function at-starup only once, cause if TitanBar is loaded with in-game plugin manager some control does not update properly v**
	OneTimer = Turbine.UI.Control();
	
	if ShowShards or ShowSkirmishMarks or ShowEquipInfos or ShowDurabilityInfos then OneTimer:SetWantsUpdates( true ); NumSec = 0; end
	if ProfileReload then OneTimer:SetWantsUpdates( false ); ProfileReload = false; end --TitanBar was reloaded cause a profil was loaded
	
	OneTimer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentsecond = currentdate.Second;
		
		if NumSec < 20 then -- Run for 20 secs.
			if (oldsecond ~= currentsecond) then
				--[[
				-- Try to detect when UI is available
				local LotroUIIs = Turbine.UI.Lotro.LotroUI:IsEnabled(); -- Not working
				--write("OneTimer: " .. NumSec .. " secs - LotroUI is enabled? " .. tostring(LotroUIIs));
				if NumSec <= 1 then seconds = "sec"; else seconds = "secs"; end
				--write("OneTimer: " .. NumSec .. " " .. seconds);
				
				if ShowShards or ShowSkirmishMarks or ShowMedallions or ShowSeals or ShowCommendations then
					LoadPlayerWallet();
					if PlayerWalletSize ~= nil then
						--WOK = true;
						if ShowShards then ImportCtr( "SP" ); end
						if ShowSkirmishMarks then ImportCtr( "SM" ); end
						if ShowMedallions then ImportCtr( "MP" ); end
						if ShowSeals then ImportCtr( "SL" ); end
						if ShowCommendations then ImportCtr( "CP" ); end
					end
				else
					WOK = true;
				end
				]]
				if ShowEquipInfos or ShowDurabilityInfos then GetEquipmentInfos();
					if PlayerEquipment ~= nil then
						--EOK = true;
						if ShowEquipInfos then UpdateEquipsInfos();	end
						if ShowDurabilityInfos then UpdateDurabilityInfos(); end
					end
				--else
					--EOK = true;
				end
				
				oldsecond = currentsecond;
				NumSec = NumSec + 1;

				--if EOK then OneTimer:SetWantsUpdates( false ); end
				--if EOK and NumSec < 17 then NumSec = 17; end

				if _G.Debug then
					if NumSec <= 1 then seconds = "sec"; else seconds = "secs"; end
					write("OneTimer: It took " .. NumSec .. " " .. seconds .. " for all infos to be available!");
				end
			end
		else
			OneTimer:SetWantsUpdates( false );
		end
	end
	--**
	--**v Run these functions all the time v**
	AllTimer = Turbine.UI.Control();
	AllTimer:SetWantsUpdates( true );
	
	AllTimer.Update = function( sender, args )
		local currentdate = Turbine.Engine.GetDate();
		local currentminute = currentdate.Minute;
		local currentsecond = currentdate.Second;
		
		if (oldminute ~= currentminute) then
			if ShowGameTime then UpdateGameTime(); end -- Until i found the minute Changed event or something similar
			oldminute = currentminute;
		end

		--Detect if wallet size as change
		if (oldsecond ~= currentsecond) then
			if PlayerWallet:GetSize() ~= PlayerWalletSize then
				LoadPlayerWallet();
				if ShowShards then ImportCtr( "SP" ); end
				if ShowSkirmishMarks then ImportCtr( "SM" ); end
				if ShowMedallions then ImportCtr( "MP" ); end
				if ShowSeals then ImportCtr( "SL" ); end
				if ShowCommendations then ImportCtr( "CP" ); end
				oldsecond = currentsecond;
			end
		end

		--When player log out & log in with same character, the durability control show -1%
		-- Cause  equipment info are not avail when re-login, weird!
		if PlayerAlign == 1 and ShowDurabilityInfos then if DI["Lbl"]:GetText() == "-1%" then GetEquipmentInfos(); UpdateDurabilityInfos(); end	end
	end
	--**
end