-- functions.lua
-- Written By Habna


function AddCallback(object, event, callback)
	--write("Add Event: " .. tostring(event));
	--write("Add Callback: " .. tostring(callback));
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
	--write("Remove Event: " .. tostring(event));
	--write("Remove Callback: " .. tostring(callback));
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

--**v Create a ToolTip Window v**
function createToolTipWin( xOffset, yOffset, xSize, ySize, side, header, text1, text2, text3 )
	local txt = {text1, text2, text3};
	ToolTipWin = Turbine.UI.Window();
	ToolTipWin:SetSize( xSize, ySize );
	--ToolTipWin:SetBackColor( Color["red"] ); -- Debug purpose
	--ToolTipWin:SetMouseVisible( false );
	--ToolTipWin:SetZOrder( 15 );
	ToolTipWin.xOffset = xOffset;
	ToolTipWin.yOffset = yOffset;

	--**v Top left corner v**
	topLeftCorner = Turbine.UI.Control();
	topLeftCorner:SetParent( ToolTipWin );
	topLeftCorner:SetPosition( 0, 0 );
	topLeftCorner:SetSize( 15, 12 );
	if side == "left" then topLeftCorner:SetBackground( resources.LeftBubble_TopLeftCorner.Background );
	elseif side == "right" then	topLeftCorner:SetBackground( resources.RightBubble_TopLeftCorner.Background ); end
	--**^
	--**v Mid Left v**
	midLeft = Turbine.UI.Control();
	midLeft:SetParent( ToolTipWin );
	midLeft:SetPosition( 0, 12 );
	midLeft:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midLeft:SetBackground( resources.Bubble_MidLeft.Background );
	--**^
	--**v Bottom Left Corner v**
	botLeftCorner = Turbine.UI.Control();
	botLeftCorner:SetParent( ToolTipWin );
	botLeftCorner:SetPosition( 0, ToolTipWin:GetHeight() - 12 );
	botLeftCorner:SetSize( 15, 12 );
	botLeftCorner:SetBackground( resources.Bubble_BotLeftCorner.Background );
	--**^
	--**v Top v**
	TopBar = Turbine.UI.Control();
	TopBar:SetParent( ToolTipWin );
	TopBar:SetPosition( 15, 0 );
	TopBar:SetSize( ToolTipWin:GetWidth() - 15, 12 );
	TopBar:SetBackground( resources.Bubble_Top.Background );
	--**^
	--**v Middle v**
	MidMid = Turbine.UI.Control();
	MidMid:SetParent( ToolTipWin );
	MidMid:SetPosition( 15, 12 );
	MidMid:SetSize( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	MidMid:SetBackground( resources.Bubble_Mid.Background );
	--**^
	--**v Bottom v**
	BotBar = Turbine.UI.Control();
	BotBar:SetParent( ToolTipWin );
	BotBar:SetPosition( 15, ToolTipWin:GetHeight() - 12 );
	BotBar:SetSize( ToolTipWin:GetWidth() - 5, 12 );
	BotBar:SetBackground( resources.Bubble_Bot.Background );
	--**^
	--**v Top right corner v**
	topRightCorner = Turbine.UI.Control();
	topRightCorner:SetParent( ToolTipWin );
	topRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, 0 );
	topRightCorner:SetSize( 15, 12 );
	if side == "left" then topRightCorner:SetBackground( resources.LeftBubble_TopRightCorner.Background );
	elseif side == "right" then topRightCorner:SetBackground( resources.RightBubble_TopRightCorner.Background ); end
	--**^
	--**v Mid Right v**
	midRight = Turbine.UI.Control();
	midRight:SetParent( ToolTipWin );
	midRight:SetPosition( ToolTipWin:GetWidth() - 15, 12 );
	midRight:SetSize( 15, ToolTipWin:GetHeight() - 12 );
	midRight:SetBackground( resources.Bubble_MidRight.Background );
	--**^
	--**v Bottom right corner v**
	botRightCorner = Turbine.UI.Control();
	botRightCorner:SetParent( ToolTipWin );
	botRightCorner:SetPosition( ToolTipWin:GetWidth() - 15, ToolTipWin:GetHeight() - 12 );
	botRightCorner:SetSize( 15, 12 );
	botRightCorner:SetBackground( resources.Bubble_BotRightCorner.Background );
	--**^
	--**v Text in Header v**
	lblheader = Turbine.UI.Label();
	lblheader:SetParent( ToolTipWin );
	lblheader:SetPosition( 10, 10 );
	lblheader:SetSize( xSize, ySize );
	lblheader:SetForeColor( Color["blue"] );
	lblheader:SetFont(Turbine.UI.Lotro.Font.Verdana16);
	lblheader:SetText( header );
	--**^
	
	local YPos = 25;
	
	--**v Text v**
	for i = 1, 3 do
		local lbltext = Turbine.UI.Label();
		lbltext:SetParent( ToolTipWin );
		lbltext:SetPosition( 10, YPos );
		lbltext:SetSize( xSize, 15 );
		lbltext:SetForeColor( Color["black"] );
		lbltext:SetFont(Turbine.UI.Lotro.Font.Verdana14);
		lbltext:SetText( txt[i] );
		YPos = YPos + 15;
	end
	--**^

	return ToolTipWin;
end

-- Legend
-- ( offsetX, offsetY, width, height, bubble side, header text, text1, text2, text3, text4 )
function ShowToolTipWin( ToShow )
	local bblTo, x, y, w = "left", 0, -17, 0;
	local mouseX, mouseY = Turbine.UI.Display.GetMousePosition();
	
	w = 235;
	if TBLocale == "fr" then w = 300; end
	if TBLocale == "de" then
		if ToShow == "DI" then w = 225;
		elseif ToShow == "PIcon" then w = string.len(L["PIICON"] .. PlayerRaceIs .. PlayerClassIs) * 7.9; --w = 245;
		else w = 210;
		end
	end

	if ToShow == "MoneyG" then -- Money infos Gold
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["MGh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "MoneyS" then -- Money infos Silver
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["MSh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "MoneyC" then -- Money infos Copper
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["MCh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "DP" then -- Destiny points
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["DPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "SP" then -- Shards
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["SPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "SM" then -- Skirmish marks
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["SMh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "MP" then -- Medallions
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["MPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "SL" then -- Seals
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["SLh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "CP" then -- Commendations
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["CPh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "Bag" then --Bag infos
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["BIh"], L["BIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "PIcon" then -- Player class
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PIICON"] .. PlayerRaceIs .. PlayerClassIs, L["EIt2"], L["EIt3"] );
	elseif ToShow == "PLvl" then -- Player level
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PILVL"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "PName" then -- Player name
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PINAME"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "EI" then -- Equipment infos
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["EIh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "DI" then -- Durability infos
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["DIh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "PL" then -- Player Location
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 60, bblTo, L["PLh"], L["EIt2"], L["EIt3"] );
	elseif ToShow == "GT" then -- Game Time
		if w + mouseX > screenWidth then bblTo = "right"; x = w - 17; end
		TTW = createToolTipWin( x, y, w, 75, bblTo, L["GTh"], L["EIt1"], L["EIt2"], L["EIt3"] );
	end

	ToolTipWin:SetPosition( mouseX - ToolTipWin.xOffset, mouseY - ToolTipWin.yOffset);
	ToolTipWin:SetVisible( true );
end
--**^
--**v Update money on TitanBar v**
function UpdateMoney()
	local money = PlayerAtt:GetMoney();
	local cp = math.fmod( money, 100 ); -- Copper
	money = ( money - cp) / 100;
	local sp = math.fmod( money, 1000 ); -- Silver
	local gp = ( money - sp ) / 1000; -- Gold
	
	MI["GLbl"]:SetText( string.format("%.0f", gp) );
	MI["GLbl"]:SetPosition( 5, 0 );
	MI["GLbl"]:SetSize( string.len(MI["GLbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	MI["GIcon"]:SetPosition( MI["GLbl"]:GetLeft() + MI["GLbl"]:GetWidth() - 2, 4 );

	MI["SLbl"]:SetText( string.format("%.0f", sp) );
	MI["SLbl"]:SetPosition( MI["GIcon"]:GetLeft() + MI["GIcon"]:GetWidth() + 5, 0 );
	MI["SIcon"]:SetPosition( MI["SLbl"]:GetLeft() + MI["SLbl"]:GetWidth() - 2, 4 );

	MI["CLbl"]:SetText( string.format("%.0f", cp) );
	MI["CLbl"]:SetPosition( MI["SIcon"]:GetLeft() + MI["SIcon"]:GetWidth() + 5, 0 );
	MI["CIcon"]:SetPosition( MI["CLbl"]:GetLeft() + MI["CLbl"]:GetWidth() - 2, 4 );
	
	MI["Ctr"]:SetSize( MI["GLbl"]:GetWidth() + MI["GIcon"]:GetWidth() + MI["SLbl"]:GetWidth() + MI["SIcon"]:GetWidth() + MI["CLbl"]:GetWidth() + MI["CIcon"]:GetWidth() + 15, TB["win"]:GetHeight() )

	SaveCharacterMoney();

	if _G.STM then --Show Total Money of all character on TitanBar Money control.
		MI["GLbl"]:SetText( string.format("%.0f", GoldTot) );
		MI["GLbl"]:SetPosition( 5, 0 );
		MI["GLbl"]:SetSize( string.len(MI["GLbl"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
		MI["GIcon"]:SetPosition( MI["GLbl"]:GetLeft() + MI["GLbl"]:GetWidth() - 2, 4 );

		MI["SLbl"]:SetText( string.format("%.0f", SilverTot) );
		MI["SLbl"]:SetPosition( MI["GIcon"]:GetLeft() + MI["GIcon"]:GetWidth() + 5, 0 );
		MI["SIcon"]:SetPosition( MI["SLbl"]:GetLeft() + MI["SLbl"]:GetWidth() - 2, 4 );

		MI["CLbl"]:SetText( string.format("%.0f", CopperTot) );
		MI["CLbl"]:SetPosition( MI["SIcon"]:GetLeft() + MI["SIcon"]:GetWidth() + 5, 0 );
		MI["CIcon"]:SetPosition( MI["CLbl"]:GetLeft() + MI["CLbl"]:GetWidth() - 2, 4 );
	
		MI["Ctr"]:SetSize( MI["GLbl"]:GetWidth() + MI["GIcon"]:GetWidth() + MI["SLbl"]:GetWidth() + MI["SIcon"]:GetWidth() + MI["CLbl"]:GetWidth() + MI["CIcon"]:GetWidth() + 15, TB["win"]:GetHeight() )
	end
end
--**^
--**v Update destiny point currency on TitanBar v**
function UpdateDestinyPoints()
	DP["Lbl"]:SetText( PlayerAtt:GetDestinyPoints() );
	DP["Lbl"]:SetSize( string.len(DP["Lbl"]:GetText()) * 7.2, TB["win"]:GetHeight() ); --Auto size with text lenght
	DP["Icon"]:SetPosition( DP["Lbl"]:GetWidth() + 7, 4 );

	DP["Ctr"]:SetSize( DP["Lbl"]:GetWidth() + DP["Icon"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^
--**v Update Shards currency on TitanBar v**
function UpdateShards()
	SP["Lbl"]:SetText( GetCurrency( pwShard ) );
	SP["Lbl"]:SetSize( string.len(SP["Lbl"]:GetText()) * 7.2, TB["win"]:GetHeight() ); --Auto size with text lenght
	SP["Icon"]:SetPosition( SP["Lbl"]:GetWidth() + 2, -2 );

	SP["Ctr"]:SetSize( SP["Lbl"]:GetWidth() + SP["Icon"]:GetWidth() - 5, TB["win"]:GetHeight() );
end
--**^
--**v Update Shards currency on TitanBar v**
function UpdateMarks()
	SM["Lbl"]:SetText( GetCurrency( pwMark ) );
	SM["Lbl"]:SetSize( string.len(SM["Lbl"]:GetText()) * 7.2, TB["win"]:GetHeight() ); --Auto size with text lenght
	SM["Icon"]:SetPosition( SM["Lbl"]:GetWidth() + 7, -1 );

	SM["Ctr"]:SetSize( SM["Lbl"]:GetWidth() + SM["Icon"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^
--**v Update Medallions currency on TitanBar v**
function UpdateMedallions()
	MP["Lbl"]:SetText( GetCurrency( pwMedallion ) );
	MP["Lbl"]:SetSize( string.len(MP["Lbl"]:GetText()) * 7.2, TB["win"]:GetHeight() ); --Auto size with text lenght
	MP["Icon"]:SetPosition( MP["Lbl"]:GetWidth() + 7, -2 );

	MP["Ctr"]:SetSize( MP["Lbl"]:GetWidth() + MP["Icon"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^
--**v Update Shards currency on TitanBar v**
function UpdateSeals()
	SL["Lbl"]:SetText( GetCurrency( pwSeal ) );
	SL["Lbl"]:SetSize( string.len(SL["Lbl"]:GetText()) * 7.2, TB["win"]:GetHeight() ); --Auto size with text lenght
	SL["Icon"]:SetPosition( SL["Lbl"]:GetWidth() + 7, -1 );

	SL["Ctr"]:SetSize( SL["Lbl"]:GetWidth() + SL["Icon"]:GetWidth() +7, TB["win"]:GetHeight() );
end
--**^
--**v Update Commendations currency on TitanBar v**
function UpdateCommendations()
	CP["Lbl"]:SetText( GetCurrency( pwCommendation ) );
	CP["Lbl"]:SetSize( string.len(CP["Lbl"]:GetText()) * 7.2, TB["win"]:GetHeight() ); --Auto size with text lenght
	CP["Icon"]:SetPosition( CP["Lbl"]:GetWidth() + 7, -1 );

	CP["Ctr"]:SetSize( CP["Lbl"]:GetWidth() + CP["Icon"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^
--**v Update backpack infos on TitanBar v**
function UpdateBackpackInfos()
	local max = Backpack:GetSize();
	local freeslots = 0;

	for i = 1, max do
		if ( Backpack:GetItem( i ) == nil ) then freeslots = freeslots + 1; end
	end

	BI["Lbl"]:SetText( max - freeslots .. "/" .. max );
end
--**^
--**v Update player infos on TitanBar v**
function UpdatePlayersInfos()
	PlayerRaceIs = Player:GetRace();

	--Free people race
	if PlayerRaceIs == 0 then PlayerRaceIs = ""; -- Undefined
	elseif PlayerRaceIs == 65 then PlayerRaceIs = L["Elf"];
	elseif PlayerRaceIs == 23 then PlayerRaceIs = L["Man"];
	elseif PlayerRaceIs == 73 then PlayerRaceIs = L["Dwarf"];
	elseif PlayerRaceIs == 81 then PlayerRaceIs = L["Hobbit"]; end

	--Monster play race
	if PlayerRaceIs == 7 then PlayerRaceIs = ""; end

	PlayerClassIs = Player:GetClass();
	if PlayerClassIs == 23 then PlayerClassIs = L["Guardian"]; PlayerIconCodeIs = "0x41007dd8"; end
	if PlayerClassIs == 24 then PlayerClassIs = L["Captain"]; PlayerIconCodeIs = "0x41007dd7"; end
	if PlayerClassIs == 31 then PlayerClassIs = L["Minstrel"]; PlayerIconCodeIs = "0x41007dd6"; end
	if PlayerClassIs == 40 then PlayerClassIs = L["Burglar"]; PlayerIconCodeIs = "0x41007ddb"; end
	if PlayerClassIs == 162 then PlayerClassIs = L["Hunter"]; PlayerIconCodeIs = "0x41007dda"; end
	if PlayerClassIs == 172 then PlayerClassIs = L["Champion"]; PlayerIconCodeIs = "0x41007ddc"; end
	if PlayerClassIs == 185 then PlayerClassIs = L["Lore-Master"]; PlayerIconCodeIs = "0x41007dd9"; end
	if PlayerClassIs == 191 then PlayerClassIs = L["Ranger"]; PlayerIconCodeIs = "default"; end --???  Default icon code, need real one thought
	if PlayerClassIs == 193 then PlayerClassIs = L["Rune-Keeper"]; PlayerIconCodeIs = "runekeeper"; end --Using my icon, need in-game one thought
	if PlayerClassIs == 194 then PlayerClassIs = L["Warden"]; PlayerIconCodeIs = "warden"; end --Using my icon, need in-game one thought

	--Monster Play Class
	if PlayerClassIs == 71 then PlayerClassIs = L["Reaver"]; PlayerIconCodeIs = "0x41007ddd"; end
	if PlayerClassIs == 127 then PlayerClassIs = L["Weaver"]; PlayerIconCodeIs = "0x41007de0"; end
	if PlayerClassIs == 179 then PlayerClassIs = L["Blackarrow"]; PlayerIconCodeIs = "0x41007ddf"; end
	if PlayerClassIs == 52 then PlayerClassIs = L["Warleader"]; PlayerIconCodeIs = "0x41007dde"; end
	if PlayerClassIs == 126 then PlayerClassIs = L["Stalker"]; PlayerIconCodeIs = "0x41007de1"; end
	if PlayerClassIs == 128 then PlayerClassIs = L["Defiler"]; PlayerIconCodeIs = "0x41008500";  end --Using red eye icon, need in-game one thought

	-- 0x41008500 (red eye) 32x32
	
	if PlayerIconCodeIs == "default" then PI["Icon"]:SetBackground( resources.Ring.Icon );
	elseif PlayerIconCodeIs == "runekeeper" then PI["Icon"]:SetBackground( resources.RuneKeeper.Icon );
	elseif PlayerIconCodeIs == "warden" then PI["Icon"]:SetBackground( resources.Warden.Icon );
	else PI["Icon"]:SetBackground( tonumber(PlayerIconCodeIs) ); end 
	--PI["Name"]:SetText( "OneBigLongCharacterName" ); --Debug purpose
	PI["Name"]:SetText( Player:GetName() );
	PI["Name"]:SetSize( string.len(PI["Name"]:GetText()) * 7.5, TB["win"]:GetHeight() ); --Auto size with text lenght
	PI["Lvl"]:SetText( Player:GetLevel() );
	PI["Lvl"]:SetSize( string.len(PI["Lvl"]:GetText()) * 8, TB["win"]:GetHeight() ); --Auto size with text lenght
	PI["Name"]:SetPosition( PI["Lvl"]:GetLeft() + PI["Lvl"]:GetWidth() + 2, 0 );

	PI["Ctr"]:SetSize( PI["Icon"]:GetWidth() + PI["Lvl"]:GetWidth() + PI["Name"]:GetWidth() + 9, TB["win"]:GetHeight() );
end
--**^
--**v Update equipment infos on TitanBar v**
function UpdateEquipsInfos( sender, args )
	for i = 1, 20 do
		local PlayerEquipItem = PlayerEquipment:GetItem( EquipSlots[Slots[i]] );
		local TItem = Turbine.UI.Lotro.ItemControl( EquipSlots[Slots[i]] );

		-- Item Quality & Durability
		if PlayerEquipItem ~= nil then
			itemEquip[i].Quality = PlayerEquipItem:GetQuality();
			itemEquip[i].Durability = PlayerEquipItem:GetDurability();
		else
			itemEquip[i].Quality = 0;
			itemEquip[i].Durability = 0;
		end
	end

	CalculateAllItemsScore();

	EI["Lbl"]:SetText( itemTotScore );

	if ShowDurabilityInfos then UpdateDurabilityInfos(); end
end
--**^

function ChangeItem(value, whattodo)
	-- Set new Quality & Durability in table
	--itemEquip[value].Quality = PlayerEquipment:GetItem( EquipSlots[Slots[value]] ):GetQuality();
	--itemEquip[value].Durability = PlayerEquipment:GetItem( EquipSlots[Slots[value]] ):GetDurability();

	--CalculateAllItemsScore();
	--UpdateEquipsInfos();
end

function ChangeWearState(value)
	-- Set new wear state in table
	itemEquip[value].WearState = PlayerEquipment:GetItem( EquipSlots[Slots[value]] ):GetWearState();

	CalculateAllItemsDurability();
	UpdateDurabilityInfos();
end

--**v Update Player Durability infos on TitanBar v**
function UpdateDurabilityInfos()
	--write( "TitanBar: Updating Durability infos");
	CalculateAllItemsDurability();

	--if itemsTotDurability == 100 then itemsTotDurability = string.format( "%.0f", itemsTotDurability );
	--else itemsTotDurability = string.format( "%.2f", itemsTotDurability ); end

	itemsTotDurability = string.format( "%.0f", itemsTotDurability );
	
	DI["Lbl"]:SetText( itemsTotDurability .. "%" );
end
--**^

--**v Update Player Location on TitanBar v**
function UpdatePlayerLoc( value )
	--write( "TitanBar: Updating Player Location");

	PL["Lbl"]:SetText( value );
	PL["Lbl"]:SetSize( string.len(PL["Lbl"]:GetText()) * 7.1, TB["win"]:GetHeight() ); --Auto size with text lenght
	PL["Lbl"]:SetPosition( 5, 0 );

	PL["Ctr"]:SetSize( PL["Lbl"]:GetWidth() + 7, TB["win"]:GetHeight() );
end
--**^
--**v Update game time on TitanBar v**
function UpdateGameTime()
	--write( "TitanBar: Updating Game Time");
	local currentdate = Turbine.Engine.GetDate();
	local currenthour = currentdate.Hour;
	local currentminute = currentdate.Minute;
	local ampm = "";
	
	if currentminute < 10 then currentminute = "0" .. currentminute; end

	-- Convert 24h to 12h format
	if not Clock24h then
		if currenthour == 12 then ampm = "pm";
		elseif currenthour >= 13 then currenthour = currenthour - 12; ampm = "pm";
		else ampm = "am" end
	end
	--
	
	GT["Lbl"]:SetText( currenthour .. ":" .. currentminute .. ampm );
	GT["Lbl"]:SetSize( string.len(GT["Lbl"]:GetText()) * 8, TB["win"]:GetHeight() ); --Auto size with text lenght

	GT["Ctr"]:SetSize( GT["Lbl"]:GetWidth() + 5, TB["win"]:GetHeight() );
end
--**^

-- **v Change back color v**
function ChangeColor()
	if SetToAll then
		TB["win"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) );
		if ShowMoney then MI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDestinyPoints then DP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowShards then SP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowSkirmishMarks then SM["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowMedallions then MP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowSeals then SL["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowCommendations then CP["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowBagInfos then BI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowPlayerInfos then PI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowEquipInfos then EI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowDurabilityInfos then DI["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end

		if ShowPlayerLoc then PL["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
		if ShowGameTime then GT["Ctr"]:SetBackColor( Turbine.UI.Color(curSelAlpha, curSelRed, curSelGreen, curSelBlue) ); end
	else
		TB["win"]:SetBackColor( Turbine.UI.Color(bcAlpha, bcRed, bcGreen, bcBlue) );
		if ShowMoney then MI["Ctr"]:SetBackColor( Turbine.UI.Color(MIbcAlpha, MIbcRed, MIbcGreen, MIbcBlue) ); end
		if ShowDestinyPoints then DP["Ctr"]:SetBackColor( Turbine.UI.Color(DPbcAlpha, DPbcRed, DPbcGreen, DPbcBlue) ); end
		if ShowShards then SP["Ctr"]:SetBackColor( Turbine.UI.Color(SPbcAlpha, SPbcRed, SPbcGreen, SPbcBlue) ); end
		if ShowSkirmishMarks then SM["Ctr"]:SetBackColor( Turbine.UI.Color(SMbcAlpha, SMbcRed, SMbcGreen, SMbcBlue) ); end
		if ShowMedallions then MP["Ctr"]:SetBackColor( Turbine.UI.Color(MPbcAlpha, MPbcRed, MPbcGreen, MPbcBlue) ); end
		if ShowSeals then SL["Ctr"]:SetBackColor( Turbine.UI.Color(SLbcAlpha, SLbcRed, SLbcGreen, SLbcBlue) ); end
		if ShowCommendations then CP["Ctr"]:SetBackColor( Turbine.UI.Color(CPbcAlpha, CPbcRed, CPbcGreen, CPbcBlue) ); end
		if ShowBagInfos then BI["Ctr"]:SetBackColor( Turbine.UI.Color(BIbcAlpha, BIbcRed, BIbcGreen, BIbcBlue) ); end
		if ShowPlayerInfos then PI["Ctr"]:SetBackColor( Turbine.UI.Color(PIbcAlpha, PIbcRed, PIbcGreen, PIbcBlue) ); end
		if ShowEquipInfos then EI["Ctr"]:SetBackColor( Turbine.UI.Color(EIbcAlpha, EIbcRed, EIbcGreen, EIbcBlue) ); end
		if ShowDurabilityInfos then DI["Ctr"]:SetBackColor( Turbine.UI.Color(DIbcAlpha, DIbcRed, DIbcGreen, DIbcBlue) ); end

		if ShowPlayerLoc then PL["Ctr"]:SetBackColor( Turbine.UI.Color(PLbcAlpha, PLbcRed, PLbcGreen, PLbcBlue) ); end
		if ShowGameTime then GT["Ctr"]:SetBackColor( Turbine.UI.Color(GTbcAlpha, GTbcRed, GTbcGreen, GTbcBlue) ); end
		
		if sFrom == "TitanBar" then TB["win"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "Money" then MI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DP" then DP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "SP" then SP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "SM" then SM["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "MP" then MP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "SL" then SL["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "CP" then CP["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "BI" then BI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "PI" then PI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "EI" then EI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "DI" then DI["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end

		if sFrom == "PL" then PL["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
		if sFrom == "GT" then GT["Ctr"]:SetBackColor( Turbine.UI.Color( curSelAlpha, curSelRed, curSelGreen, curSelBlue ) ); end
	end
end
--**^


function LoadEquipmentTable()
	EquipSlots = {
		["Earring1"] = Turbine.Gameplay.Equipment.Earring1; --no 13
		["Earring2"] = Turbine.Gameplay.Equipment.Earring2; --no 14
		["Necklace"] = Turbine.Gameplay.Equipment.Necklace; --no 10
		["Pocket"] = Turbine.Gameplay.Equipment.Pocket; --no 15
		["Bracelet1"] = Turbine.Gameplay.Equipment.Bracelet1; --no 8
		["Bracelet2"] = Turbine.Gameplay.Equipment.Bracelet2; --no 9
		["Ring1"] = Turbine.Gameplay.Equipment.Ring1; --no 11
		["Ring2"] = Turbine.Gameplay.Equipment.Ring2; --no 12
		["Head"] = Turbine.Gameplay.Equipment.Head; --no 1
		["Shoulder"] = Turbine.Gameplay.Equipment.Shoulder; --no 6
		["Back"] = Turbine.Gameplay.Equipment.Back; --no 7
		["Chest"] = Turbine.Gameplay.Equipment.Chest; --no 2
		["Gloves"] = Turbine.Gameplay.Equipment.Gloves; --no 4
		["Legs"] = Turbine.Gameplay.Equipment.Legs; --no 3
		["Boots"] = Turbine.Gameplay.Equipment.Boots; --no 5
		["PrimaryWeapon"] = Turbine.Gameplay.Equipment.PrimaryWeapon; --no 16
		["SecondaryWeapon"] = Turbine.Gameplay.Equipment.SecondaryWeapon; --no 17
		["RangedWeapon"] = Turbine.Gameplay.Equipment.RangedWeapon; --no 18
		["Class"] = Turbine.Gameplay.Equipment.Class; --no 20
		["CraftTool"] = Turbine.Gameplay.Equipment.CraftTool; --no 19
	};

	Slots = {"Head", "Earring1", "Earring2", "Necklace", "Shoulder", "Back", "Chest", "Bracelet1", "Bracelet2",
		"Ring1", "Ring2", "Gloves", "Legs", "Boots", "Pocket", "PrimaryWeapon", "SecondaryWeapon", "RangedWeapon",
		"CraftTool", "Class"};
end

-- For debug purpose
function ShowTableContent(table)
	for k,v in pairs(table) do
		write("key:"..tostring(k)..", value:"..tostring(v));
	end
end