-- profile.lua
-- Written by Habna


function frmProfile()
	frmP = true;
	settings.Profile.V = false;
	SaveSettings( false );

	wProfile = Turbine.UI.Lotro.Window();
	--wProfile = Turbine.UI.Lotro.GoldWindow()
	
	wProfile:SetText( L["MPP"] );
	wProfile:SetWidth( 250 );
	wProfile:SetVisible( true );
	wProfile:SetWantsKeyEvents( true );
	--wProfile:SetZOrder( 2 );
	wProfile:Activate();

	wProfile.KeyDown = function( sender, args )
		if ( args.Action == Turbine.UI.Lotro.Action.Escape ) then
			wProfile:Close();
		elseif ( args.Action == 268435635 ) or ( args.Action == 268435579 ) then -- Hide if F12 key is press or reposition UI
			wProfile:SetVisible( not wProfile:IsVisible() );
		end
	end

	wProfile.MouseUp = function( sender, args )
		settings.Profile.L = string.format("%.0f", wProfile:GetLeft());
		settings.Profile.T = string.format("%.0f", wProfile:GetTop());
		PPWLeft, PPWTop = wProfile:GetPosition();
		SaveSettings( false );
	end

	wProfile.Closing = function( sender, args )
		wProfile = nil;
		frmP = nil;
		opt_profile:SetEnabled( true );
	end

	ListBox = Turbine.UI.ListBox();
	ListBox:SetParent( wProfile );
	ListBox:SetPosition( 20, 40 );
	ListBox:SetSize( wProfile:GetWidth() - 40, 20 );
	ListBox:SetMaxItemsPerLine( 1 );
	ListBox:SetOrientation( Turbine.UI.Orientation.Horizontal );
	--ListBox:SetBackColor( Color["darkgrey"] ); --debug purpose

	buttonLoad = Turbine.UI.Lotro.Button();
	buttonLoad:SetParent( wProfile );
	buttonLoad:SetText( L["PWLoad"] );
	buttonLoad:SetSize( string.len(buttonLoad:GetText()) * 11, 15 ); --Auto size with text lenght
	buttonLoad:SetEnabled( false );

	buttonLoad.Click = function( sender, args )
		write(L["PWProfil"] .. " '" .. lblName[PrevItemClic]:GetText() .. "' " .. L["PWLoaded"]);
		settings = vPProfileSettings[PrevItemClic];
		settings.Profile.V = true;
		SaveSettings( false );
		ReloadTitanBar();
	end

	buttonCreate = Turbine.UI.Lotro.Button();
	buttonCreate:SetParent( wProfile );
	buttonCreate:SetText( L["PWCreate"] );
	buttonCreate:SetSize( string.len(buttonCreate:GetText()) * 11, 15 ); --Auto size with text lenght
	buttonCreate:SetEnabled( true );

	buttonCreate.Click = function( sender, args )
		CreateCtr:SetVisible( true );
		InputBox:SetText( L["PWEPN"] );
		InputBox:Focus();
		buttonLoad:SetVisible( false );
		buttonCreate:SetVisible( false );
		wProfile:SetHeight( wProfile:GetHeight() + 25 );
	end

	CreateCtr = Turbine.UI.Control();
	CreateCtr:SetParent( wProfile );
	CreateCtr:SetSize( ListBox:GetWidth(), 45 );
	CreateCtr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
	CreateCtr:SetVisible( false );
	--CreateCtr:SetBackColor( Color["red"] ); -- Debug purpose

	InputBox = Turbine.UI.Lotro.TextBox();
	InputBox:SetParent( CreateCtr );
	InputBox:SetSize( CreateCtr:GetWidth(), 20 );
	InputBox:SetPosition( 0, 0 );
	InputBox:SetMultiline( false );
	InputBox:SetFont( Turbine.UI.Lotro.Font.TrajanPro14 );

	InputBox.FocusGained = function( sender, args )
		InputBox:SelectAll();
	end
	
	buttonSave = Turbine.UI.Lotro.Button();
	buttonSave:SetParent( CreateCtr );
	buttonSave:SetText( L["PWSave"] );
	buttonSave:SetSize( string.len(buttonSave:GetText()) * 10, 15 ); --Auto size with text lenght
	buttonSave:SetPosition( 0, 25 );
	buttonSave:SetEnabled( true );

	buttonSave.Click = function( sender, args )
		if InputBox:GetText() == "" then
			InputBox:SetText( L["PWEPN"] );
			InputBox:Focus();
			return
		elseif InputBox:GetText() == L["PWEPN"] then
			InputBox:Focus();
			return
		end

		settings.PlayerLoc.L = L["PLMsg"];

		local vProfile = {};
		vProfile[InputBox:GetText()] = settings;
		table.insert( PProfile, vProfile );
		
		-- The table key is saved with "," in DE & FR client. Ex. [1,000000]. This cause a parse error.
		-- If you change [1,000000] to [1.000000] error not there anymore. [1] would be easier! Why all does zeros!
		-- So Turbine save the table key in the client language but lua is unable to read it since "," is a special character.
		-- Turbine just have to save the key in english and the value in the client language.

		-- So i'm converting the key [1,000000] into a string like this ["1"]
		-- That's VindarPatch is doing, it convert the hole table into string (key and value)
		-- Me I only need to convert the key since value are already in the correct language format.
		local newt = {};
		for i, v in pairs(PProfile) do newt[tostring(i)] = v end
		PProfile = newt;

		settings.Profile.V = true;
		SavePlayerProfile();
		SaveSettings( false );
		ReloadTitanBar(); -- Need to reload, because if create more then 1 profile, previous profile will be lost!
		--[[
		CreateCtr:SetVisible( false );
		buttonLoad:SetVisible( true );
		buttonLoad:SetEnabled( false );
		buttonCreate:SetVisible( true );
		RefreshListBox();
		]]
	end

	buttonCancel = Turbine.UI.Lotro.Button();
	buttonCancel:SetParent( CreateCtr );
	buttonCancel:SetText( L["PWCancel"] );
	buttonCancel:SetSize( string.len(buttonCancel:GetText()) * 10, 15 ); --Auto size with text lenght
	buttonCancel:SetPosition( buttonSave:GetLeft() + buttonSave:GetWidth() + 5, 25 );
	buttonCancel:SetEnabled( true );

	buttonCancel.Click = function( sender, args )
		CreateCtr:SetVisible( false );
		buttonLoad:SetVisible( true );
		buttonCreate:SetVisible( true );
		wProfile:SetHeight( wProfile:GetHeight() - 25 );
	end

	RefreshListBox();

    wProfile:SetPosition( PPWLeft, PPWTop );
end

function RefreshListBox()
	local PosY = 20;
	Ctr, DelIcon, lblName, vPProfile = {}, {}, {}, {};
	PrevItemClic, i = 0, 1;
	ListBox:ClearItems();

	vPProfile = {};
	vPProfileSettings = {};

	-- Convert the table key that is in string format into a number, so it can be viewed by lua correctly.
	local newt = {}
	for i, v in pairs(PProfile) do newt[tonumber(i)] = v end
	PProfile = newt;

	if #PProfile == 0 then
		local Ctr = Turbine.UI.Control();
		Ctr:SetParent( ListBox );
		Ctr:SetSize( ListBox:GetWidth(), 20 );
		Ctr:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
		--Ctr:SetBackColor( Color["red"] ); -- Debug purpose

		--**v Profil name v**
		local lblName = Turbine.UI.Label();
		lblName:SetParent( Ctr );
		--lblName:SetFont ( 12 );
		lblName:SetText( L["PWNFound"] );
		lblName:SetPosition( 0, 0 );
		lblName:SetSize( Ctr:GetWidth(), Ctr:GetHeight() );
		lblName:SetForeColor( Color["green"] );
		lblName:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
		--lblName:SetBackColor( Color["red"] ); -- debug purpose
		--**^

		ListBox:AddItem( Ctr );
	else
		for i = 1, #PProfile do
			for k,v in pairs(PProfile[i]) do
				vPProfile[i] = k;
				vPProfileSettings[i] = v;
			end

			Ctr[i] = Turbine.UI.Control();
			Ctr[i]:SetParent( wProfile );
			Ctr[i]:SetSize( ListBox:GetWidth(), 20 );
			Ctr[i]:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
			--Ctr[i]:SetBackColor( Color["red"] ); -- Debug purpose

			--**v Delete icon v**
			DelIcon[i] = Turbine.UI.Label();
			DelIcon[i]:SetParent( Ctr[i] );
			DelIcon[i]:SetPosition( 0, 2 );
			DelIcon[i]:SetSize(16, 16);
			DelIcon[i]:SetBackground( resources.Del.Icon );
			DelIcon[i]:SetBlendMode( Turbine.UI.BlendMode.AlphaBlend );
			DelIcon[i]:SetVisible( true );
			--DelIcon[i]:SetBackColor( Color["blue"] ); -- debug purpose
				
			DelIcon[i].MouseClick = function( sender, args )
				if ( args.Button == Turbine.UI.MouseButton.Left ) then
					write(L["PWProfil"] .. " '" .. lblName[i]:GetText() .. "' " .. L["PWDeleted"]);
					table.remove( PProfile, i );

					local newt = {};
					for i, v in pairs(PProfile) do newt[tostring(i)] = v; end
					PProfile = newt;

					SavePlayerProfile();
					RefreshListBox();
				end
			end
			--**^

			--**v Profil name v**
			lblName[i] = Turbine.UI.Label();
			lblName[i]:SetParent( Ctr[i] );
			lblName[i]:SetText( vPProfile[i] );
			lblName[i]:SetPosition( 21, 0 );
			lblName[i].Id = i;
			lblName[i].Sel = false;
			lblName[i]:SetSize( ListBox:GetWidth() - 21, 20 );
			lblName[i]:SetForeColor( Color["green"] );
			lblName[i]:SetTextAlignment( Turbine.UI.ContentAlignment.MiddleLeft );
			lblName[i]:SetBackColorBlendMode( Turbine.UI.BlendMode.Overlay );
			--lblName[i]:SetBackColor( Color["red"] ); -- debug purpose
			--**^
		
			lblName[i].MouseClick = function( sender, args )
				if PrevItemClic ~= 0 then
					lblName[PrevItemClic]:SetBackColor( Color["none"] );
					lblName[PrevItemClic].Sel = false;
				end
				PrevItemClic = lblName[i].Id;
				lblName[i].Sel = true;
				buttonLoad:SetEnabled( true );
			end

			lblName[i].MouseHover = function(sender, args)
				lblName[i]:SetBackColor( Color["lightgrey"] );
			end

			lblName[i].MouseLeave = function(sender, args)
				if lblName[i].Sel then lblName[i]:SetBackColor( Color["stblue"] ); else lblName[i]:SetBackColor( Color["none"] ); end
			end

			ListBox:AddItem( Ctr[i] );
			ListBox:SetHeight( PosY );

			PosY = PosY + 20;
		end
	end

	PerformLayout();
end

function PerformLayout()
	buttonLoad:SetPosition( 20, ListBox:GetTop() + ListBox:GetHeight() + 5 );
	buttonCreate:SetPosition( buttonLoad:GetLeft() + buttonLoad:GetWidth() + 15, ListBox:GetTop() + ListBox:GetHeight() + 5 );

	CreateCtr:SetPosition( 20, buttonLoad:GetTop() );

	wProfile:SetHeight( ListBox:GetHeight() + buttonLoad:GetHeight() + 60 );
	if CreateCtr:IsVisible() then wProfile:SetHeight( wProfile:GetHeight() + 25 ); end
end